﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text.RegularExpressions;

[Serializable]
[SqlUserDefinedAggregate(Format.Native)]
public struct BAND
{
    private SqlInt32 _value;
    public SqlInt32 Value
    {
        get
        {
            return _value;
        }
        set
        {
            _value = value;
        }
    }
    public void Init()
    {
        _value = new SqlInt32(-1);
    }

    public void Accumulate(SqlInt32 value)
    {
        _value = SqlInt32.BitwiseAnd(value, _value);
    }

    public void Merge(BAND Group)
    {
        _value = SqlInt32.BitwiseAnd(Group.Value, _value);
    }

    public SqlInt32 Terminate()
    {
        return _value;
    }
}
[Serializable]
[SqlUserDefinedAggregate(Format.Native)]
public struct CountMatches
{
    private SqlInt32 _matches;
    public SqlInt32 Matches
    {
        get
        {
            return _matches;
        }
        set
        {
            _matches = value;
        }
    }
    public void Init()
    {
        _matches = new SqlInt32(0);
    }

    public void Accumulate(SqlString data, SqlString model)
    {
        Regex reg = new Regex(model.ToString());

        Match rm = reg.Match(data.ToString());
        if ((rm != null) && (rm.Success))
        {
            _matches = SqlInt32.Add(_matches, 1);
        }
    }

    public void Merge(CountMatches Group)
    {
        _matches = SqlInt32.Add(Group.Matches, _matches);
    }

    public SqlInt32 Terminate()
    {
        return _matches;
    }
}
