﻿using System;
using System.Data;
using System.Data.SqlClient;
using Microsoft.SqlServer.Server;

public partial class Triggers
{
    // Event: The DML action that activates the trigger could be an UPDATE, a DELETE, or an INSERT action. The type of the trigger can be AFTER (FOR) or INSTEAD OF.
    [SqlTrigger (Name="UpdateSampleTable", Target="sample_table", Event="FOR UPDATE")]
    public static void UpdateSampleTableTrigger()
    {
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        {
            // You can obtain some information from SqlContext.TriggerContext
            string updatemsg = "updated columns: ";
            string comma = "";
            for (int ic = 0; ic < SqlContext.TriggerContext.ColumnCount; ic++)
            {
                if (SqlContext.TriggerContext.IsUpdatedColumn(ic))
                {
                    updatemsg += comma + ic.ToString();
                    comma = ",";
                }
            }
            SqlCommand LogCommand = new SqlCommand(
                "insert into log_table(table_name,log_message,log_date) " +
                "values('sample_table', @msg, getdate())", conn);
            LogCommand.Parameters.AddWithValue("msg", updatemsg);
            conn.Open();
            LogCommand.ExecuteNonQuery();
            conn.Close();
        }
    }
    [SqlTrigger(Name = "InsteadOfDeleteSampleTableTrigger", Target = "sample_table", Event = "INSTEAD OF DELETE")]
    public static void InsteadOfDeleteSampleTableTrigger()
    {
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        {            
            SqlCommand LogCommand = new SqlCommand(
                "insert into log_table(table_name,log_message,log_date) " +
                "values('sample_table', SYSTEM_USER + ' tried to delete record', getdate())", conn);
            conn.Open();
            LogCommand.ExecuteNonQuery();
            conn.Close();
        }
    }
}

